PRO wflat,list,dd,ff
;
;Flatfielding of white-light frames.
;INPUT:  list - string array with names of raw files
;	 dd - darkfield array (float)
;	 ff - flatfield array (float)
;OUTPUT: plain binary files, 1528x1024, integer, values multiplied by 10000,
;	 name 'wfXX.seq', where XX is the date and seq the frame number,
;	 equal to the subscript of list array (beginning from 0).
;CALLED: f1.pro to read raw images

;*****************path & name to be modified *****************

path='25jun/'
name=path+'wf25.'

;*************************************************************

fd=ff-dd		;flatfield - dark
si=size(list)
for i=0,si(1)-1 do begin
  im=f1(path+list(i))
  im=im(4:1531,4:1027)	;setting working field
  im=(im-dd)/fd		;this is float
  im=fix(10000*im)	;this is integer scaled to 10000
  openw,1,name+strtrim(i,2)
  print, 'Processing ',list(i),' , writing ',name+strtrim(i,2)
  writeu,1,im
  close,1
endfor

END
