FUNCTION mtele,d

; Calculation of 1-D theoretical MTF of a diffraction-limited telescope.
; calling: RESULT = MTELE(d)

	STP=0.1658    ;0.06218    ; STEP OF RESTORED IMAGES (arcsec/pix)
	lambda=1.5542d-4 ;5.250d-5   ; WORKING WAVELENGTH (cm)
	n=320             ; SIZE (LENGTH) OF ARRAY (pixels)
      ; d = DIAMETER OF THE TELESCOPE (cm)
	t=dblarr(n)

	c=lambda*2.06265d5/(d*n*STP)
	ss=0
	   for i=1,n do begin
	      
	      omega=c*(i-1)
	      if omega lt 1.d0 then begin
	        TT=acos(omega)-omega*sqrt(1.-omega^2)
	      endif else begin
                ss=ss+1
		if ss eq 1 then print,'cutoff: ',i-1
	        TT=0.d0
	      endelse
	      T(i-1)=2.*TT/3.141592654d0

	   endfor
RETURN, T
end

