; IDL program to make a PS figure of UDs  - (pore P4)
;  - histograms of lifetimes
;		avg. intensities
;		effective diameters
;		avg. velocity magnitudes

restore,'resp4b'

histo,resp4b(0,*),x1,y1,bin=5,min=1,max=71
; histo,resp4b(0,0:29),x6,y6,bin=5,min=1,max=71
histo,resp4b(8,*),x2,y2,bin=0.04,min=0.46,max=0.96
histo,resp4b(10,*),x3,y3,bin=0.02,min=0.23,max=0.54
histo,resp4b(7,*),x4,y4,bin=0.1,min=0.04,max=1
histo,resp4b(7,where(resp4b(0,*) gt 10)),x5,y5,bin=0.1,min=0.04,max=1

set_plot,'ps'
device,filename='p4fig3.ps',xsize=18,ysize=18,xoffset=1,yoffset=9

!p.multi=[0,2,2,0,0]

plot,x1,y1,psym=10, $	;ticklen=-0.02, $
    xra=[0,75],/xst, $
;    xra=[-10,280],/xst,yra=[-10,150],/yst, $	;axes shifted
    xtitle='Lifetime (minutes), bin=5', $
    ytitle='Normalized number of UDs', $
    charsize=1.,thick=2,xthick=2,ythick=2,charthick=2
; oplot,x6,y6,psym=10,linestyle=1,thick=2
xyouts,66,0.267,'a',charsiz=1.2

plot,x2,y2,psym=10, $
;    xra=[0.2,0.65],/xst,yra=[0,0.14],/yst, $
    xtitle='Time-averaged brightness, bin=0.04', $
    ytitle='Normalized number of UDs', $
    charsize=1.,thick=2,xthick=2,ythick=2,charthick=2, $
    xticks=6,xtickn=['0.4','0.5','0.6','0.7','0.8','0.9','1.0'], $
    xminor=2
xyouts,0.93,0.178,'b',charsiz=1.2

plot,x3,y3,psym=10, $
    xra=[0.2,0.55],/xst, $                     ;yra=[0,40],/yst,
    xtitle='Effective diameter ("), bin=0.02', $
    ytitle='Normalized number of UDs', $
    charsize=1.,thick=2,xthick=2,ythick=2,charthick=2, $
    xticks=7,xtickn=['0.2',' ','0.3',' ','0.4',' ','0.5',' ']
xyouts,0.51,0.224,'c',charsiz=1.2

plot,x4,y4,psym=10, $
    yra=[0,0.35],/yst, $
    xtitle='Time-averaged velocity (km/s), bin=0.1', $
    ytitle='Normalized number of UDs', $
    charsize=1.,thick=2,xthick=2,ythick=2,charthick=2
oplot,x5,y5,psym=10,linestyle=1,thick=2
xyouts,0.88,0.315,'d',charsiz=1.2

device,/close
!p.multi=0
set_plot,'x'

end
