PRO stabil_p,llx,lly,pore,scam
;
;procedure para corregir una serie de imagenes tomadas en La Palma, de
;los shift de la imagen producidos por defectos de tracking.  

;
;ATENCION: cuando una serie de imagenes es muy larga (mas de 135 imagenes),
;se corregira por subseries de unas 135 imagenes teniendo buen cuidado
;al fijar los indices nprim,nnn,nsub,ninit,nfin. El shift se corrige 
;respecto de la primera imagen de la serie completa.
;La 2a,3a,4a,... subseries tendran como primera imagen la ultima de la
;subserie anterior (original=sin corregir), y el numero de esta imagen 
;(nfin de la subserie anterior) sera el nuevo ninit.
;
;Las entradas se dan mediante editor: numero de la primera imagen
;de la serie completa, numero total de imagenes de la serie
;completa, numero de orden de la sub-serie que se procesa (=1 para la 
;primera), numero de la imagen inicial de la subserie que se procesa, 
;numero de la imagen final de la subserie que se procesa, dimension de 
;las imagenes, delimitacion de la caja para correlar y paths para lectura 
;y deposito de imagenes.
;
;
;Este programa es una version del gr.pro solo para shift.
;
;Editado el 12 de Junio de 1995. Introducida la correccion opcional de trend
;en la caja de correlacion el 22 de Febrero de 1994.
;
;Editado por Michal 20 Nov 95 para alinear los subfields de poros:
;
;    llx,lly = lower-left corner of stabilized subfield
;    pore =	    pore 'p5' or 'p6' (STRING!!)
;    scam =	    camera 'a' or 'b' (STRING!!)


;---------------------------------------------------------------------------

; SERIES 23 OF 30Jun95 - REALIGNMENT OF QUIET GRANULATION SUBFIELD

;definicion de parametros de entrada

	nprim=1             ;no. de la primera imagen de la serie completa.
	nnn=220             ;no. total de imagenes de la serie completa.
	nsub=1              ;no. de orden de la subserie que se procesa.
	ninit=1             ;numero de la imagen inicial de la subserie.
	nfin=220            ;numero de la imagen final de la subserie. 

	n=1280      ;dimension x of source image
	m=1032      ;dimension y       "     "

	wx=288 ;192	    ;dimension x of stabilized subfield
	wy=288 ;192	    ;dimension y        "         "
        
	;delimitacion de la caja para correlar con ALIGN_CROSS. Dimensiones
	;de la caja = mejor potencias de 2

	itrend=0  ;correccion opcional de trend en caja de correlacion= 0 , 1

	n1=llx     ;coordenada x menor de la caja
	n2=llx+287 ;coordenada x mayor de la caja
	m1=lly     ;coordenada y menor de la caja
	m2=lly+287 ;coordenada y mayor de la caja
	nn=268     ;dimension x de la subcaja a desplazar en la correlacion
	mm=268     ;dimension y de la subcaja a desplazar en la correlacion

;definicion de los paths

   st1a=string(scam+'_ser23/'+scam+'_ser23.')
						;prefijo imagenes entrada
   st1b=string('/net/junco/scratch/sob/lap95/im'+scam+'/'+scam+'_'+pore+'.')
						;prefijo imagenes salida

;----------------------------------------------------------------------------

;prepara arrays para depositar los shifts acumulativos (x,y),
;asi como las matrices imagen.

	x = fltarr(nnn)
	y = fltarr(nnn)
	iimage = intarr(n,m,/nozero)


;procesa la primera imagen de la subserie


	dcn=strtrim(ninit,2)
	print,'Leyendo la primera imagen:'
	print,st1a+dcn
	openr,unit,st1a+dcn,/get_lun
	readu,unit,iimage
	free_lun,unit
	image=float(iimage)
	if (nsub eq 1) then begin     ;caso para la primera subserie
		x(0)=0.;define = 0 el desplazamiento de la primera imagen
		y(0)=0.;de la serie completa.
		;deposita la primera imagen de la serie completa.
		print,' Escribiendo la primera imagen de la serie completa'
		print,st1b+dcn
		openw,unit,st1b+dcn,/get_lun

		writeu,unit,nint(image(llx:llx+wx-1,lly:lly+wy-1)) ;subfield

		free_lun,unit
	endif else begin            ;caso para la 2a, 3a, ... subseries
		RESTORE,'gr_data'
	
	endelse
	ima=image(n1:n2,m1:m2)
	if itrend eq 1 then ima=ima-sfit(ima,2);corrige de trend
	ref=ima


;ciclo de lectura de imagenes sucesivas, correccion de shift
;y deposito de la imagen resultante

	FOR i = ninit+1,nfin DO BEGIN
		dcn=strtrim(i,2)
		print,'Leyendo nueva imagen:'
		print,st1a+dcn
		openr,unit,st1a+dcn,/get_lun
		readu,unit,iimage
		free_lun,unit
		image=float(iimage)
		ii=i-nprim
		ima=image(n1:n2,m1:m2)
		if itrend eq 1 then ima=ima-sfit(ima,2);corrige de trend	
		dxy = ALIGN_CROSS(ref,ima,nn,mm)   ;proced.lib.OSLO. Uti-
			;liza correlacion por Fourier. Da como resultado
			;el desplazamiento que hay que darle a 'image'
			;para que se superponga a 'ref'.
		ref=ima ;referencia para shift entre imagenes consecutivas.
		x(ii) = x(ii-1)+dxy(0)  ;shift acumulativo en x
		y(ii) = y(ii-1)+dxy(1)  ;shift acumulativo en y
		;corrige de shift acumulativo
		image = SHIFT(image,nint(x(ii)),nint(y(ii)));rutina IDL. Solo
			;trabaja con shifts = numero entero de pixels (o sea
			;que no interpola). Convenio de signos: 
			;desplaz.dcha = +, desplaz.izq. = -.
		;deposita el resultado
		print,' Escribiendo la imagen resultante'
		print,st1b+dcn
		openw,unit,st1b+dcn,/get_lun

		writeu,unit,nint(image(llx:llx+wx-1,lly:lly+wy-1)) ;subfield

		free_lun,unit

	ENDFOR
;	SAVE,x,y,filename='gr_data'+pore+scam

END
