PRO vipenet,par,ps=ps

; Plotting the results of MANTRACK: 14 features penetrating into P4
; Input parameter PAR: 0 - Max.intensity, 3 - Avg.intensity.
;                      4 - size (Deff, "), 5 - spwwd (km/s) 
;	  ps   - keyword. If set, PS figures are made

on_error,1

if keyword_set(ps) then begin
  set_plot,'ps'
  device,file='rplot'+strtrim(par,2)+'.ps',/landscape, $
    xoffs=3,yoffs=27,xsize=24,ysize=15	;centimeters
  print,'rplot'+strtrim(par,2)+'.ps'
endif else begin
  window,0
endelse

restore,'r0ffset'
for i=1,14 do  restore,'r'+strtrim(i,2)

si=size(r1)
tim=(findgen(si(2))-r0ffset(0))/3.

CASE par OF
0: begin
   plot,tim,r1(par,*),xra=[-8,14],/xst,yra=[0.5,1.4],/yst, $
     xtitle='Time (minutes)',ytitle='Peak intensity'
   plots,[0,0],[0.5,1.4],/data
   end
3: begin
   plot,tim,r1(par,*),xra=[-8,14],/xst,yra=[0.5,1.2],/yst, $
     xtitle='Time (minutes)',ytitle='Avg. intensity'
   plots,[0,0],[0.5,1.2],/data
   end
4: begin
   plot,tim,r1(par,*),xra=[-8,14],/xst,yra=[0.2,1.1],/yst, $
     xtitle='Time (minutes)',ytitle='Diameter (")'
   plots,[0,0],[0.2,1.1],/data
   end
5: begin
   plot,tim,r1(par,*),xra=[-8,14],/xst,yra=[0,3.5],/yst, $
     xtitle='Time (minutes)',ytitle='Velocity (km/s)'
   plots,[0,0],[0,3.5],/data
   end
else: message,'Allowed values are 0,3,4,5'
ENDCASE

si=size(r2)
tim=(findgen(si(2))-r0ffset(1))/3.
oplot,tim,r2(par,*)

si=size(r3)
tim=(findgen(si(2))-r0ffset(2))/3.
oplot,tim,r3(par,*)

si=size(r4)
tim=(findgen(si(2))-r0ffset(3))/3.
oplot,tim,r4(par,*)

si=size(r5)
tim=(findgen(si(2))-r0ffset(4))/3.
oplot,tim,r5(par,*)

si=size(r6)
tim=(findgen(si(2))-r0ffset(5))/3.
oplot,tim,r6(par,*)

si=size(r7)
tim=(findgen(si(2))-r0ffset(6))/3.
oplot,tim,r7(par,*)

si=size(r8)
tim=(findgen(si(2))-r0ffset(7))/3.
oplot,tim,r8(par,*)

si=size(r9)
tim=(findgen(si(2))-r0ffset(8))/3.
oplot,tim,r9(par,*)

si=size(r10)
tim=(findgen(si(2))-r0ffset(9))/3.
oplot,tim,r10(par,*)

si=size(r11)
tim=(findgen(si(2))-r0ffset(10))/3.
oplot,tim,r11(par,*)

si=size(r12)
tim=(findgen(si(2))-r0ffset(11))/3.
oplot,tim,r12(par,*)

si=size(r13)
tim=(findgen(si(2))-r0ffset(12))/3.
oplot,tim,r13(par,*)

si=size(r14)
tim=(findgen(si(2))-r0ffset(13))/3.
oplot,tim,r14(par,*)

if keyword_set(ps) then begin
  device,/close
  set_plot,'x'
endif

END

