PRO sigfil,in,out

;1-D FOURIER SIGNAL FILTERING
;IN = 1-D input array (equidistant sampling)
;OUT= 1-D filtered array
;Calling: FILTERS.PRO

si=size(in)
if si(0) gt 1 then begin
  print,'I CAN FILTER ONLY 1-D ARRAYS'
  out=0
  goto,fin
endif
n=si(1)		;array lenth
nrep=2*n-1	;array length after replication

ffin=fft([in,reverse(in(1:n-1))],-1)	 ;fourier transform
pfin=(float(ffin))^2+(imaginary(ffin))^2 ;power spectrum
pfin(0)=pfin(1)				 ;for better plotting range
window,1
plot_io,pfin(0:n-1)>1.e-4,back=255,col=0,title='POWER'

;filter design
newfil:
read,'Filter type, Band type:  ',fity,baty
read,'Cutoff, Order, Bandwidth (pixels):  ',cut,ord,ban
filt=FILTERS(nrep,fity,baty,cut,ord,ban)

;filtering
out=fft(ffin*filt,1)
out=float(out(0:n-1))
wset,0
window,0
plot,in,back=255,col=120,/yst,title='SIGNAL'
oplot,out,col=0
print,'imaginary part, min, max:',min(imaginary(ffin)),max(imaginary(ffin))
print,'Filtering OK ? (y/n)'
if get_kbrd(1) eq 'n' then goto,newfil

fin:
END
