PRO idud,tug,tuc,maxdi
;
; Mutual identification of UDs in the 'gc' and 'c6' images.
; UDs are identical if the distance between the 'gc' and 'c6'
; positions is less or equal to the limit 'MAXDI' (3 pix).
; Multiple identifications are discarded.
; INPUTS: tug, tuc = 2D LONG arrays/tables for UDs in 'gc','c6'
;		     obtained by UDSEGM.
; OUTPUT: tug, tuc = overwritten arrays/tables for UDs in 'gc','c6
;		     re-sorted (and purged), so that their lines
;		     correspond to the same object.
;

sg=size(tug)
sc=size(tuc)
id=intarr(2,sg(2))+(-1)	; list of UDs seq.nos. (0-gc, 1-c6)
madi=maxdi^2		; to avoid square root in distance

for i=0,sg(2)-1 do begin	; loop over 'gc' UDs

  dist=(tug(0,i)-tuc(0,*))^2+(tug(1,i)-tuc(1,*))^2 ;array of distances
  w=where(dist le madi,cnt)

; w = list of 'c6' UDs that are within maxdi from 'gc'.
; If there is one, ok. If none or more, do not record it.
  
  if cnt eq 1 then begin
	id(0,i)=i
	id(1,i)=w(0)
  endif

endfor

id=id(*,where(id(0,*) ge 0,cnt))	; purge the list
tug1=lonarr(sg(1),cnt)			; make new tables
tuc1=lonarr(sc(1),cnt)
tug1(*,*)=tug(*,id(0,*))		; fill the tables
tuc1(*,*)=tuc(*,id(1,*))
tug=tug1
tuc=tuc1
print,'Identified GC with C6:',cnt

END

